#pragma once
using namespace std;

#define long_proc typedef long (__stdcall *zProc)
#define MAKLNG(a, b) ((LONG) (((WORD) (a)) | ((DWORD) ((WORD) (b))) << 16))
#define LOINT(a) ((SHORT)(a))
#define HIINT(a) ((SHORT)(((DWORD)(a) >> 16) & 0xFFFF))

long zTrace(IN WCHAR* sPtr) {
    long nRet = 0;
    static HMODULE hDll;
    if (hDll == 0) {
        if (sizeof(LONG_PTR) == 8) {
            hDll = LoadLibrary(L"zTrace64");
        }
        else {
            hDll = LoadLibrary(L"zTrace32");
        }
    }
    if (hDll) {
        long_proc(WCHAR*);
        static zProc hProc;
        if (hProc == 0) { hProc = (zProc)GetProcAddress(hDll, "zTrace"); }
        if (hProc) { nRet = hProc(sPtr); }
    }
    return nRet;
}

long dpi(IN long nPix) {
    static float ratio;
    if (ratio == 0) {
        HDC hDC = GetDC(NULL); 
        ratio = (GetDeviceCaps(hDC, LOGPIXELSX) / 96.0f);
        ReleaseDC(NULL, hDC);
    }
    return (long) (nPix * ratio);
}

WCHAR* STRL(IN long N) {
    static WCHAR longstr[33] = { 0 };
    _ltow_s(N, longstr, 10);
    return (WCHAR*)longstr;
}

WCHAR* CHR$(IN long n) {
    static WCHAR bb[2] = { 0 };
    bb[0] = n % 255;
    return (WCHAR*) bb;
}

long INSTRPOS(IN WCHAR* sMain, IN WCHAR* sSearch) {
    long sMainSize = (long) wcslen(sMain);
    long sSearchSize = (long) wcslen(sSearch);
    long nRet = 0;
    if (sMainSize > sSearchSize) {
        for ( int i = 0 ; i <= sMainSize - sSearchSize; ++i ) {
             if (wcsncmp(&sMain[i], sSearch, sSearchSize) == 0 ) {
                 nRet = i + 1;
                 break;
             }
        }
    }
    return nRet;
}

WCHAR* ListGetText (IN HWND hList, IN long nItem) {
    static WCHAR szData[MAX_PATH];
    memset(szData, 0, sizeof(WCHAR));
    if (nItem > 0) {
        --nItem; SendMessage(hList, LB_GETTEXT, nItem, (LPARAM) szData);
    }
    return szData;
}

LRESULT ListAdd(IN HWND hList, IN WCHAR* zTmp) {
    LRESULT nIndex = 0;
    if (IsWindow(hList)) {
       if (wcslen(zTmp)) { nIndex = SendMessage(hList, LB_ADDSTRING, 0, (LPARAM) zTmp); }
    }
    return nIndex;
}

#define MyBitTest(Var, Pos) ((Var) & (1 << (Pos)))

long IsKeyDown (IN long CheckKey) {
    long KeyDown = GetAsyncKeyState(CheckKey);
    return MyBitTest(KeyDown, 15);
}

long IsLButtonDown () {
    long nRet = 0;
    if (IsKeyDown(1)) { nRet = -1; }
    return nRet;
}
